/*
 File: o2_lcl_optssym.cpp
 Date and Time: Fri Jan 30 18:55:17 2015 
*/
#include "o2_lcl_opts.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_o2_lcl_opts;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Co2_lcl_opts::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Ryacco2_options_:{
       Ryacco2_options* sym;
     if(re->rule_ == 0){
       sym = new Ryacco2_options(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ryacco2_options*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     sym->op();
     return;}
    case rhs1_Reog_:{
       Reog* sym;
     if(re->rule_ == 0){
       sym = new Reog(parser__);
       re->rule_ = sym;
     }else{
       sym = (Reog*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Reog_:{
       Reog* sym;
     if(re->rule_ == 0){
       sym = new Reog(parser__);
       re->rule_ = sym;
     }else{
       sym = (Reog*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs1_Rws_k_:{
       Rws_k* sym;
     if(re->rule_ == 0){
       sym = new Rws_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rws_k_:{
       Rws_k* sym;
     if(re->rule_ == 0){
       sym = new Rws_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rws_k_s_:{
       Rws_k_s* sym;
     if(re->rule_ == 0){
       sym = new Rws_k_s(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k_s*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rws_k_s_:{
       Rws_k_s* sym;
     if(re->rule_ == 0){
       sym = new Rws_k_s(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k_s*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs1_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs4_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs1_Rparms_epi_:{
       Rparms_epi* sym;
     if(re->rule_ == 0){
       sym = new Rparms_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparms_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rparms_epi_:{
       Rparms_epi* sym;
     if(re->rule_ == 0){
       sym = new Rparms_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparms_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rparms_:{
       Rparms* sym;
     if(re->rule_ == 0){
       sym = new Rparms(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparms*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rparms_:{
       Rparms* sym;
     if(re->rule_ == 0){
       sym = new Rparms(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparms*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rspec_parm_:{
       Rspec_parm* sym;
     if(re->rule_ == 0){
       sym = new Rspec_parm(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rspec_parm*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rspec_parm_:{
       Rspec_parm* sym;
     if(re->rule_ == 0){
       sym = new Rspec_parm(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rspec_parm*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rspec_parm_:{
       Rspec_parm* sym;
     if(re->rule_ == 0){
       sym = new Rspec_parm(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rspec_parm*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rspec_parm_:{
       Rspec_parm* sym;
     if(re->rule_ == 0){
       sym = new Rspec_parm(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rspec_parm*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    default: return;
   }
}
